<?php
/**
 * @category   Newsroom
 * @package    Newsroom_Presskit
 * @author     dushyantjoshia@gmail.com
 * @copyright  This file was generated by using Module Creator(http://code.vky.co.in/magento-2-module-creator/) provided by VKY <viky.031290@gmail.com>
 * @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */

namespace Newsroom\Presskit\Block;

use Magento\Framework\View\Element\Template\Context;
use Newsroom\Presskit\Model\PresskitFactory;

/**
 * Presskit List block
 */
class PresskitListData extends \Magento\Framework\View\Element\Template {
	/**
	 * @var Presskit
	 */
	protected $_presskit;

	protected $_catalogLayer;
	protected $_categoryCollection;
	protected $_storeManager;
	protected $_categoryRepository;
	public function __construct(
		Context $context,

		\Magento\Store\Model\StoreManagerInterface $storeManager,
		\Magento\Catalog\Model\ResourceModel\Category\CollectionFactory $categoryCollection,
		\Magento\Catalog\Model\CategoryRepository $categoryRepository,
		PresskitFactory $presskit
	) {
		$this->_presskit = $presskit;

		$this->_categoryCollection = $categoryCollection;
		$this->_categoryRepository = $categoryRepository;
		$this->_storeManager = $storeManager;
		parent::__construct($context);
	}
	/**
	 * Retrieve current store level 2 category
	 *
	 * @param bool|string $sorted (if true display collection sorted as name otherwise sorted as based on id asc)
	 * @param bool $asCollection (if true display all category otherwise display second level category menu visible category for current store)
	 * @param bool $toLoad
	 */
	public function loadCategory($id = '') {
		return $this->_categoryRepository->get($id);
		# code...
	}
	public function getStoreCategories($sorted = false, $asCollection = false, $toLoad = true) {
		return $collection = $this->_categoryCollection->create()
			->addAttributeToSelect('*')
			->setStore($this->_storeManager->getStore())
		//->addAttributeToFilter('attribute_code', '1')
			->addAttributeToFilter('is_active', '1');
	}
	public function _prepareLayout() {
		$this->pageConfig->getTitle()->set(__('Media Coverage'));

		if ($this->getPresskitCollection()) {
			$pager = $this->getLayout()->createBlock(
				'Magento\Theme\Block\Html\Pager',
				'newsroom.presskit.pager'
			)->setAvailableLimit(array(10 => 10, 20 => 20, 30 => 30))->setShowPerPage(true)->setCollection(
				$this->getPresskitCollection()
			);
			$this->setChild('pager', $pager);
			$this->getPresskitCollection()->load();
		}
		return parent::_prepareLayout();
	}

	public function getPresskitCollection() {
		$page = ($this->getRequest()->getParam('p')) ? $this->getRequest()->getParam('p') : 1;
		$pageSize = ($this->getRequest()->getParam('limit')) ? $this->getRequest()->getParam('limit') : 10;

		$presskit = $this->_presskit->create();
		$collection = $presskit->getCollection();
		$collection->addFieldToFilter('status', '1');
		$collection->setOrder('presskit_id','DESC');
		$collection->setPageSize($pageSize);
		$collection->setCurPage($page);
		
		return $collection;
	}

	public function getPagerHtml() {
		return $this->getChildHtml('pager');
	}
}